package se.ericsson.eto.norarc.javaframe;
import se.ericsson.eto.norarc.javaframe.debug.*;

public class DebugMailBox extends MailBox {
	
	DebugMailBox (MailBox mBox) {

		firstMessage = mBox.firstMessage;
		lastMessage = mBox.lastMessage;
		moveMailBox(mBox);
		

	}
	
	/**
	  * Adds the Message sig to the end of this MailBox.
	  * @param sig assumed to be != null.
	  */
	synchronized protected void addMessage(Message sig) {
		
		// let the DebugControl know of the message
		if (!DebugControl.getInstance().signalRecieved(sig, this)) {
			// getInstance returns false if the signal shouldn't be added to the mailbox
			System.out.println("DebugMailBox: discarding signal " + sig);
			return;
		}
		
	    if (firstMessage == null)
	      firstMessage = sig;
	    else
	      lastMessage.nextMessage = sig;
	    lastMessage = sig;
	    sig.nextMessage = null;
	  }
}
