package se.ericsson.eto.norarc.javaframe.debug;
import java.lang.reflect.*;
import se.ericsson.eto.norarc.javaframe.*;
import java.util.*;


/**
 * @author Jonas
 * Contains lists with attribute- and mediator-fields for a subclass of StateMachine
 */
public class StateMachineClassData {
	private Field[] attributes;
	private Field[] mediators;
	public Field[] getAttributes() {return attributes;}
	public Field[] getMediators() {return mediators;}
	
	private String qualifiedName;
	public void setQualifiedName(String s) {qualifiedName = s;}
	public String getQualifiedName() {return qualifiedName;}
	
	
	/**
	 * Collects attribute and mediator fields for a class
	 * @param c the class
	 */
	public StateMachineClassData(Class c) {
		List<Field> al = new LinkedList<Field>();
		List<Field> ml = new LinkedList<Field>();
		while (c != StateMachine.class) {
			for (Field f : c.getDeclaredFields()) {
				if (Mediator.class.isAssignableFrom(f.getType())) {
					if (Modifier.isPublic(f.getModifiers())) ml.add(f);
				} else if (f.getName().equals("states")) continue;
				else al.add(f);
			}
			c = c.getSuperclass();
		}
		System.out.println(c.getName() + ":\nattr:\n" + al + "\nmed:\n" + ml + "\n");
		attributes = al.toArray(new Field[0]);
		mediators = ml.toArray(new Field[0]);
	}
}
